#ifndef bitar_h_included_sfosodjdkgjdifi
#define bitar_h_included_sfosodjdkgjdifi

/***********************************************************************
 *                                                                     *
 *                              BIT ARRAY                              *
 *                                                                     *
 ***********************************************************************/

typedef struct bitar bitar_t;
bitar_t *bitar_new(int len);
bitar_t *bitar_dup(bitar_t *ar);
void     bitar_free(bitar_t *ar);
int      bitar_get(bitar_t *ar, int pos);
void     bitar_set(bitar_t *ar, int pos);
void     bitar_clr(bitar_t *ar, int pos);
void     bitar_clr_all(bitar_t *ar);
void     bitar_setv(bitar_t *ar, int pos, int value);

int      bitar_count1(bitar_t *ar);
int      bitar_count0(bitar_t *ar);


#endif
