#include <stdio.h>
#include <stdlib.h>

int ninputs;

static void compex(int a,int b)
{
  if (a<ninputs && b<ninputs) printf("%d %d\n", a,b);
}

static void half_clean(int start, int length)
{
  int i;
  for(i=0;i<length/2;i++)
    compex(start+i, start+i+length/2);
}

static void bitosort(int start, int length)
{
  if (length==2) { compex(start, start+1); return ; }
  half_clean(start,length);
  bitosort(start, length/2);
  bitosort(start+length/2, length/2);
}

static void merge(int start, int length)
{
  int i;
  for(i=0;i<length/2;i++)
   compex(i+start, length-1-i+start);
}

static void sort(int start, int length)
{
  if (length==2) { compex(start,start+1); return ; }

  sort(start, length/2);
  sort(start+length/2, length/2);
  merge(start, length);
  bitosort(start, length/2);
  bitosort(start+length/2, length/2);
}

int main(int argc,char **argv)
{
  int N;
  int i;
  ninputs= atoi(argv[1]);
  for(N=1;N<ninputs;N=N<<1) ;
  printf("%d\n",ninputs);
  sort(0,N);
  return 0;
}
