#ifndef __INTSET_propgldkjgdk_H_INCLUDED
#define __INTSET_propgldkjgdk_H_INCLUDED

#ifdef __cplusplus
extern "C" {
#endif

typedef struct { void *root; } intset_t;

intset_t *intset_new    ();
int       intset_find   (intset_t *map, uint32_t key);
int       intset_insert (intset_t *map, uint32_t key);
int       intset_remove (intset_t *map, uint32_t key);
int       intset_destroy(intset_t *map, uint32_t *Rkey);

#ifdef __cplusplus
};
#endif

#endif
