#ifndef rela_h_included_lkgmdgliowogd
#define rela_h_included_lkgmdgliowogd

typedef struct rela rela_t;

rela_t* rela_new(int N);
rela_t *rela_dup(rela_t *R);
void rela_free(rela_t *R);

int rela_compare(rela_t *R, int a, int b);
void rela_greater(rela_t *R,int a,int b);
void rela_less(rela_t *R, int a, int b);
void rela_remove(rela_t *R, int a, int b);

void rela_apply_transitions(rela_t *R);

void rela_print(rela_t *R);
void rela_write(FILE *f,rela_t *R);
rela_t *rela_read(FILE *f);

int rela_count0(rela_t *R);


#endif
