
int bit_count(uint32_t A);
int highest_bit(uint32_t A);
int lowest_bit(uint32_t A);
int imax2(int a,int b);
int imin2(int a,int b);

typedef struct { size_t len; uint32_t *data; } intlist_t;
typedef struct { size_t len; uint16_t *data; } sholist_t;

void unify_intlist(intlist_t *L);
void unify_sholist(sholist_t *L);

void intlist_write(FILE *f,int N, uint32_t *data);
uint32_t *intlist_read(FILE *,int N);

void sholist_write(FILE *f,int N, uint16_t *data);
uint16_t* sholist_read(FILE *f,int N);

void read_int(FILE *f,uint32_t *R); 
void write_int(FILE *f,uint32_t R);

sholist_t *sholist_new(int len);
void sholist_free(sholist_t *L);

